import java.awt.*;
import java.lang.*;
import java.io.*;

	class Edos2Gui extends Frame {
		TextField a1,a2,a3,a4,a5,a6,a7,a8,a9,a10;
		Button c1,c2,c3;
		Label l1,l2,l3,l4,l5,l6,l7,l8,l9,l10;
		Edos2Calculs calcul = null;
		SimpleDataViewer sdv = null;
		String nom = "sensenom.dat";
		float dt = 0.05f;
		float nx0 = 200;
		float ny0 = 300;
		float a = 0.75f;
		float b = 0.75f;
		float rx = 2.0f;
		float ry = 2.0f;
		float Kx = 1000.0f;
		float Ky = 1000.0f;
		int imax = 50;

		Edos2Gui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,2,10,10));
			a1 = new TextField(Float.toString(dt));
			a2 = new TextField(Integer.toString(imax));
			a3 = new TextField(Float.toString(nx0));
			a4 = new TextField(Float.toString(ny0));
			a5 = new TextField(Float.toString(a));
			a6 = new TextField(Float.toString(b));
			a7 = new TextField(Float.toString(rx));
			a8 = new TextField(Float.toString(ry));
			a9 = new TextField(Float.toString(Kx));
			a10 = new TextField(Float.toString(Ky));
			c1 = new Button("Calcula");
			c2 = new Button("Desa");
			c3 = new Button("Abandona");
			l1 = new Label("Duracio del pas");
			l2 = new Label("Nombre de passos");
			l3 = new Label("Nombre inicial x");
			l4 = new Label("Nombre inicial y");
			l5 = new Label("Parametre a");
			l6 = new Label("Parametre b");
			l7 = new Label("Parametre rx");
			l8 = new Label("Parametre ry");
			l9 = new Label("Parametre Kx");
			l10 = new Label("Parametre Ky");
			add(l1);
			add(a1);
			add(l2);
			add(a2);
			add(l3);
			add(a3);
			add(l4);
			add(a4);
			add(l5);
			add(a5);
			add(l6);
			add(a6);
			add(l7);
			add(a7);
			add(l8);
			add(a8);
			add(l9);
			add(a9);
			add(l10);
			add(a10);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcula"))
				calcular();
			if(label.equals("Desa"))
				guardar();
			if(label.equals("Abandona"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f1,f3,f4,f5,f6,f7,f8,f9,f10;
			double x0[],y00[],y01[];
			int m;

			if(sdv!=null)sdv.hide();
			sdv = new SimpleDataViewer("Visor de dades",2);
			sdv.init();
			sdv.tpt.frameWidth = 475;
			sdv.tpt.tickSeparation1 = 20;
			sdv.tpt.tickSeparation2 = 40;
			sdv.grf.lx = "Pas de temps";
			sdv.grf.ly = "Nombre d'individus";

			f1 = Float.valueOf(a1.getText());
			f3 = Float.valueOf(a3.getText());
			f4 = Float.valueOf(a4.getText());
			f5 = Float.valueOf(a5.getText());
			f6 = Float.valueOf(a6.getText());
			f7 = Float.valueOf(a7.getText());
			f8 = Float.valueOf(a8.getText());
			f9 = Float.valueOf(a9.getText());
			f10 = Float.valueOf(a10.getText());
			dt = f1.floatValue();
			imax = Integer.parseInt(a2.getText());
			nx0 = f3.floatValue();
			ny0 = f4.floatValue();
			a = f5.floatValue();
			b = f6.floatValue();
			rx = f7.floatValue();
			ry = f8.floatValue();
			Kx = f9.floatValue();
			Ky = f10.floatValue();
			calcul = new Edos2Calculs(dt,imax,nx0,ny0,a,b,rx,ry,Kx,Ky);
			c2.enable();

			x0 = new double[imax];
			y00 = new double[imax];
			y01 = new double[imax]; 

			for(m=0;m<imax;m++) {
				x0[m] = (double) m;
				y00[m] = calcul.trajx[m];
				y01[m] = calcul.trajy[m];
			}

			sdv.grf.cjt[0].initializeColor(1);
			sdv.grf.cjt[0].initializeCoordinates(x0,y00);
			sdv.grf.cjt[0].pointType=2;
			
			sdv.grf.cjt[1].initializeColor(2);
			sdv.grf.cjt[1].initializeCoordinates(x0,y01);
			sdv.grf.cjt[1].pointType=2;

			sdv.show();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int k,m;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						for(m=0;m<imax;m++) {
							linia= Double.toString(calcul.temps[m]) + " " + Double.toString(calcul.trajx[m]) + " " + Double.toString(calcul.trajy[m]) + "\n";
							sortida.write(linia);
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			Edos2DialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new Edos2DialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Desa",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
    		}
	}

	class Edos2DialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		Edos2DialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirma",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.la");
			l1 = new Label ("  El fitxer ja existeix. Vols escriure a sobre?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.la")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
		return opcio;
		}
	}

class Edos2 {

	public static void main(String args[]) {
		Edos2Gui edos2 = null;		// Declaraci d'instncies.

		edos2 = new Edos2Gui("Edos2");
		edos2.init();
		edos2.show();
	}
}

